#! /usr/bin/env python
# -*- coding: utf-8 -*-
# __author__ = "chenwei"
# Date: 2018/11/16

from utils.base import APIView


class AccountList(APIView):
    def get(self, request):
        page = request.GET.get('page', 1)
        limit = request.GET.get('limit', 10)
        filter = self.handle_filter(request.GET.get('filter', ""))
        try:
            data = self.rpc['venus/community/pick/get'](offset=page, limit=limit, filters=filter).unwrap()
        except Exception as e:
            # raise e
            pass
        data = {
        'total': 100,
        'data': [
            {'id': 1, 'nickname': '鹿晗1', 'password': '21233423', 'email': 'www.baidu.com', 'username': 'admin1'},
            {'id': 2, 'nickname': '鹿晗2', 'password': '21233423', 'email': 'www.baidu.com', 'username': 'admin2'},
            {'id': 3, 'nickname': '鹿晗3', 'password': '21233423', 'email': 'www.baidu.com', 'username': 'admin3'},
            {'id': 4, 'nickname': '鹿晗4', 'password': '21233423', 'email': 'www.baidu.com', 'username': 'admin4'},
            ]
        }
        return data

    def post(self, request):
        ids = request.POST.get('ids', '').split()
        type = request.POST.get('type', '')
        try:
            self.rpc['venus/community/account/offline_account'](type=type, ids=ids).unwrap()
        except Exception as e:
            raise e
        return {
            "message": "更新成功"
        }


class LoginView(APIView):
    def post(self, request):
        username = request.POST.get('username')
        password = request.POST.get('password')

        if username == 'admin' and password == '123123':
            return {
                'id': 1,
                'roles': ['admin'],
                'token': 'admin',
                'introduction': '我是超级管理员',
                'avatar': 'https://wpimg.wallstcn.com/f778738c-e4f8-4870-b634-56703b4acafe.gif',
                'name': 'Super Admin'
              }
        else:
            return {
                'id': 2,
                'roles': ['editor'],
                'token': 'editor',
                'introduction': '我是编辑',
                'avatar': 'https://wpimg.wallstcn.com/f778738c-e4f8-4870-b634-56703b4acafe.gif',
                'name': 'Normal Editor'
              }


class LogoutView(APIView):
    def post(self, request):
        pass


class AccountUpdateOrCreateView(APIView):
    def get(self, request):
        map = {
          'admin': {
            'roles': ['admin'],
            'token': 'admin',
            'introduction': '我是超级管理员',
            'avatar': 'https://wpimg.wallstcn.com/f778738c-e4f8-4870-b634-56703b4acafe.gif',
            'name': 'Super Admin'
          },
          'editor': {
            'roles': ['editor'],
            'token': 'editor',
            'introduction': '我是编辑',
            'avatar': 'https://wpimg.wallstcn.com/f778738c-e4f8-4870-b634-56703b4acafe.gif',
            'name': 'Normal Editor'
          }
        }
        token = request.GET.get('token')
        return {
            'data': map['admin']
        }